<cfsilent>
<!--- This work is licensed under the Creative Commons Attribution-ShareAlike 2.5 License License. 
To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/2.5/ or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.

In order to comply with the attribution clause of the Creative Commons License, 
please do not remove this and the "Developed by Blue Instant" notice

Use this application at your own risk

<rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:title>File Explorer</dc:title>
	<dc:date>2006</dc:date>
	<dc:creator><Agent><dc:title>Laura Arguello and Nahuel Foronda</dc:title></Agent></dc:creator>
	<dc:rights><Agent><dc:title>Laura Arguello and Nahuel Foronda</dc:title></Agent></dc:rights>
	<dc:source rdf:resource="http://www.asfusion.com/projects/fileexplorer" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF>
 --->


<cfset servicespath = request.fileManagerProps.servicespath />
<cfset typesWithIcons = request.fileManagerProps.typesWithIcons />
<cfset treeRootLabel = request.fileManagerProps.treeRootLabel />
<cfset files =  queryNew("Type,Name,Size,DateLastModified","varchar,varchar,varchar,date")/>
<cfset extensionsDescription = request.fileManagerProps.allowedExtensionsDescription />
<cfset extensions = ""/>
<!--- create a valid extension list for flash fileupload --->
<cfloop index="ext" list="#request.fileManagerProps.allowedExtensions#" delimiters=",">
	<cfset extensions = listappend(extensions,"*." & ext,";")/>
</cfloop>
<cfsavecontent variable="innerPanel">
	drop-shadow: false;
	background-color: #ffffff;
	headerColors:#9BC8DF,#C4E0F6;
	color:#000000;
</cfsavecontent>
<cfsavecontent variable="progressBarStyle">
	border-thickness:0;
	corner-radius: 0;
	fill-colors: #00CCFF, #0075D9;
	theme-color: #00CCFF;
	border-color:#00CCFF;
	color:#ffffff;
</cfsavecontent>
</cfsilent>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title>ASF File Explorer</title>
</head>

<body>
<cfform name="FileExplorer" format="Flash" timeout="999" onload="formOnLoad()" style="themeColor:##56A1E1;">
	<cfformitem type="script">
	var rootVerified:Boolean = false;
	var remotingService:mx.remoting.NetServiceProxy;
	
	
	<!--- make changes to styling here and the above themecolor --->
	public function setStyles():Void {
		_global.styles.Form.setStyle("color", 0x222222);
		_global.styles.Button.setStyle("color", 0x222222);
		_global.styles.Button.setStyle("borderThickness", 1);
		_global.styles.Panel.setStyle("backgroundColor", 0xE5F0F9);
		_global.styles.Panel.setStyle("color", 0xffffff);
		_global.styles.Panel.setStyle("headerColors", [0x277DC6,0x50ABF7]);
	}

<!--- this function is called when the form loads so it defines global properties --->	
public function formOnLoad(){
	
	<!--- check flash version for file upload --->
	checkVersion();
	
	<!--- set up remoting service --->
	setUpRemoting();
	
	files.getColumnAt(1).labelFunction = setFileTypeLabel;
	files.getColumnAt(1).setStyle("textAlign","center");
	files.getColumnAt(3).labelFunction = setSizeLabel;
	directories.editable = true;
	directories.setStyle("defaultLeafIcon",directories.getStyle("folderClosedIcon"));
	
	<!--- set up listeners --->
	var listener:Object = {};
	listener.nodeOpen = function(eventobj):Void {
		_root.verifyRoot();
		_root.getDirs( eventobj.node.getProperty('Path'));
	}

	listener.cellEdit = function(eventobj):Void {
		if(_root.isValidFolder(eventobj.oldValue))
			_root.renameFolder(eventobj.itemIndex);
	}
	
	directories.addEventListener('nodeOpen',listener);
	directories.addEventListener('cellEdit',listener);
	
	<!--- file edit listener --->
	listener = {};

	listener.cellEdit = function(eventobj):Void {
		_root.renameFile(eventobj.itemIndex, eventobj.oldValue);
	}
	
	files.addEventListener('cellEdit',listener);

	<!--- set up styles --->
	setStyles();
}


<!--- show image types with icons --->
public function setFileTypeLabel(item:Object, columnName:String): String {
		var img:String = "";
		<cfoutput>var knownTypes:String = "#typesWithIcons#";</cfoutput>
		
		if ( item[columnName] != undefined) {
			<!--- add the path to the item to that it knows where to find the picture --->
			var name:String = item['Name'].toLowerCase();
			
				<!--- find extension --->
				var ext = _root.getExtension(name);
				<!--- search in known types --->
				if(ext.length > 0 && knownTypes.indexOf(ext) > -1){					
					img = "icons/" + ext + ".jpg";
				}
				else{
					img = "icons/unk.jpg";
				}
			}

		return img;
	}

	<!--- format size --->
	public function setSizeLabel(item:Object, columnName:String):String {
		var label:String = "";
		
		if ( item[columnName] != undefined) {
			var kb = Math.round(item[columnName] /1024);
			label = (kb < 1024) ? ((kb == 0 && item[columnName] != 0)?"1 KB":kb + " KB"): Math.round(kb/1024) + " MB";
		}

		return label;
	}
	
<!--- function to call when the tree selection is changed --->
	public function onTreeChange(){
		verifyRoot();
		getFiles(directories.selectedNode.getProperty('Path'));			
	}
		
	<!--- just make sure we have set up the root node as we want it  --->
	public function verifyRoot(){
		if (!rootVerified){
			directories.getTreeNodeAt(0).setProperty('Path','');
			directories.getTreeNodeAt(0).setProperty('Name',directories.getTreeNodeAt(0).getProperty('label'));
		}
		rootVerified = true;
	}

	<!--- remoting handlers set up --->
public function setUpRemoting(){
	<cfoutput><!--- cfoutput to be able to set the gateway dynamically. It is recommended however to write the actual gateway instead --->
		var connection:mx.remoting.Connection = mx.remoting.NetServices.createGatewayConnection("http://#cgi.HTTP_HOST#/flashservices/gateway/");
		var componentPath = "#servicespath#.fileExplorer";
	</cfoutput>
		var responseHandler:Object  = {};
		
		<!--- put controls in function scope --->
		var files = files;
		var directories = directories;
		var messages = messages;
		var messageBox = messageBox;
		var loader = loader;
		
		<!--- default onresult --->
		responseHandler.onResult = function( results: Object ):Void {
			if (results.status && results.message.length > 0){
				_root.showMessage(results.message,"success");
			}
			else if (!results.status) {
				_root.showMessage(results.message,"error");
			}
			 loader.visible = false;
		}
		
				
		<!--- default error handler --->
		responseHandler.onStatus  = function( stat: Object ):Void {
			_root.showMessage(stat.description,"error") ;
			 loader.visible = false;
		}
		
		responseHandler.getFiles_Result = function( results: Object ):Void {
			<!--- populate file list --->
			this.onResult(results);
			if (results.status){
				_root.showMessage(results.message,"info");
				files.dataProvider = results.files;
			}			
		}
		
		responseHandler.removeFile_Result = function( results: Object ):Void {
			this.onResult(results);
		
			<!--- if we are still in this path, find it and remove it from the list --->
			if (results.status && results.path == _root.getCurrentPath()){
				var index:Number = _root.findItem(files,"Name",results.name);
				if (index > -1){
					files.removeItemAt(index);
				}
			}
		}
		
		responseHandler.renameFile_Result = function( results: Object ):Void {
			this.onResult(results);
			
			<!--- if we are still in this path, find it and remove it from the list --->
			if (results.status && results.path == _root.getCurrentPath()){
				var index:Number = _root.findItem(files,"Name",results.name);
				if (index > -1){
					files.editField(index,"Name",results.rename);
				}
			}
			else if(!results.status && results.path == _root.getCurrentPath()) {
				<!--- revert to old name --->
				var index:Number = _root.findFile(results.rename, results.size, results.lastmodified);
				if (index > -1){
					files.editField(index,"Name",results.name);
				}
			}
		}

		
		responseHandler.getDirectories_Result = function( results: Object ):Void {
			this.onResult(results);
			
			if (results.status){
				//_root.showMessage(results.message,"info");
				
				<!--- when results are back, populate the cftree --->
				<!--- find the parent --->
				var parent = _root.findNode(directories.getTreeNodeAt(0),'Path',results.path);
			
				parent.removeAll();
			
				for (var i = 0; i < results.directories.length; i++){
					var node = parent.addTreeNode(results.directories.items[i].Name, results.directories.items[i]);
					node.setProperty('Name',results.directories.items[i].Name);
					node.setProperty('Path',results.directories.items[i].Path);
					if( results.directories.items[i].hasDirs > 0 ){
						var child = node.addTreeNode('Getting sub-directories...');
					}
					
					child.setProperty('Path','--holder--');
				}
			}
		}
		
		responseHandler.createFolder_Result = function( results: Object ):Void {
			this.onResult(results);
			if (results.status){
				var node = _root.findNode(directories.getTreeNodeAt(0),'Path',results.path).addTreeNode(results.name);
				node.setProperty('Path',results.completepath);
				node.setProperty('Name',results.name);
			}
		}		
   
		
		<!--- after removing folder --->
		responseHandler.removeFolder_Result = function( results: Object ):Void {
			this.onResult(results);
			
			if (results.status){
				var node = _root.findNode(directories.getTreeNodeAt(0),'Path',results.path);
				node.removeTreeNode();
			}
		}	
		
		
		responseHandler.renameFolder_Result = function( results: Object ):Void {
			<!--- if we are still in this path, find it and remove it from the list --->
			this.onResult(results);
			
			if (results.status){
				var node = _root.findNode(directories.getTreeNodeAt(0),'Path',results.oldpath);
				node.setProperty('Path',results.renamedpath);
				node.setProperty('Name',results.rename);
				_root.getDirs(results.renamedpath);
				<!--- try to refresh the other items 
				directories.selectedNode = directories.selectedNode;--->
			}
			else {<!--- revert to old name --->
				var node = _root.findNode(directories.getTreeNodeAt(0),'Path',results.oldpath);
				if (node != undefined)
					node.setProperty('label',results.name);
			}
		}		
		
	
		<!--- store service in global variable --->	
		remotingService = connection.getService(componentPath, responseHandler );

}		

<!--- after a file has been uploaded --->
public function fileUploaded():Void{
	fileToUpload.text = "";
	getFiles(getCurrentPath());
}

<!--- user wants to see sub-directories --->
public function getDirs(path:String):Void{
	if (isValidFolder(path)){
		//prepareRemotingCall("Getting folders...");
		prepareRemotingCall("");
		remotingService.getDirectories(path);
	}
}

<!--- user is trying to see all the files in a folder --->
public function getFiles(path:String):Void{
	if (isValidFolder(path)){
		//prepareRemotingCall("Getting files...");
		prepareRemotingCall("");
		remotingService.getFiles(path);
	}
}

<!--- user wants to create a folder --->
public function submitCreateFolder():Void{
	var path = getCurrentPath();
	var name = folderName.text
	prepareRemotingCall("Creating folder...");
	remotingService.createFolder(path, name);
}

<!--- user wants to remove a file  --->
public function submitRemoveFile():Void{
	var path = getCurrentPath();
	var name = files.selectedItem.Name;
	var remotingService = remotingService;
	var myClickHandler = function (evt):Void {
        if (evt.detail == mx.controls.Alert.OK) {
			_root.prepareRemotingCall("Deleting file...");
            remotingService.removeFile(path, name);
        }
	}
	alert("Are you sure you want to del" + "ete this file?", "Warning", mx.controls.Alert.OK | mx.controls.Alert.CANCEL,  myClickHandler ,mx.controls.Alert.OK);
}

<!--- user wants to rename a file  --->
public function renameFile(index:Number,oldValue:String):Void{
	var path = getCurrentPath();
	var name = oldValue;
	var rename = files.selectedItem.Name;
	var size = files.selectedItem.Size;
	var lastModified = files.selectedItem.DateLastModified;
	prepareRemotingCall("Renaming file...");
	remotingService.renameFile(path, name, rename,lastModified,size);
}

<!--- user wants to rename a folder --->
public function renameFolder(index:Number):Void{
	var path = directories.getItemAt(index).getParent().getProperty('Path');
	var name = directories.getItemAt(index).getProperty('Name');
	var rename = directories.getItemAt(index).getProperty('label');
	
	if (isValidFolder(path) && isValidFolder(rename) && isValidFolder(name)){
		prepareRemotingCall("Renaming folder...");
		remotingService.renameFolder(path, name, rename);
	}
	else{<!--- revert name --->
		directories.getItemAt(index).setProperty('label',name);
	}
}

<!--- user wants to remove a folder --->
public function submitRemoveFolder():Void{
	var path = getCurrentPath();
	var remotingService = remotingService;
	
	var myClickHandler = function (evt):Void {
        if (evt.detail == mx.controls.Alert.OK) {
			_root.prepareRemotingCall("Removing folder...");
            remotingService.removeFolder(path);
        }
	}
	alert("Are you sure you want to del" + "ete this folder and all its contents?", "Warning", mx.controls.Alert.OK | mx.controls.Alert.CANCEL,  myClickHandler, mx.controls.Alert.OK);
}

<!--- user wants to download a file --->
public function downloadFile():Void{
	var path = getCurrentPath();
	var name = files.selectedItem.Name;
	getURL('download.cfm?path=' + path + "&filename=" + name);
}



<!--- get the currently selected node path --->
public function getCurrentPath():String {
	return directories.selectedNode.getProperty('Path');
}


<!--- find a file in the file list --->
public function findFile(name:String, size:Number, modified:String):Number {

		for (var i = 0; i < files.dataProvider.length; i++){
			if (files.getItemAt(i)['Name'] == name && files.getItemAt(i)['Size'] == size && files.getItemAt(i)['DateLastModified'] == modified){
				return i;
			}
		}
		<!--- not found --->
		return -1;
	}	
	

<!--- ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
<!--- helper functions --->
public function getExtension(name:String):String {
	return name.substr(name.lastIndexOf('.') + 1,name.length);
}

<!--- helper function to find an item in a datagrid --->
public function findItem(grid:mx.controls.DataGrid, columnToSearch:String, id:String):Number {

		for (var i = 0; i < grid.dataProvider.length; i++){
			if (grid.getItemAt(i)[columnToSearch] == id){
				return i;
			}
		}
		<!--- not found --->
		return -1;
	}
	
<!--- show an information message --->	
public function showMessage(message:String, type:String) {
	if (type == "error"){
		statusDisplay.setStyle("backgroundColor",0xFF5F5F);
		statusDisplay.setStyle("color",0xFFFFFF);
	}
	else if (type == "success"){
		statusDisplay.setStyle("backgroundColor",0xD1E7A2);
		statusDisplay.setStyle("color",0x000000);
	}
	else {
		statusDisplay.setStyle("backgroundColor",0xFFFFFF);
		statusDisplay.setStyle("color",0x000000);
	}
	statusText.text = message;
} 

<!--- showing loading icon and showing a message --->
public function prepareRemotingCall(message:String) {
	if (message.length){
		showMessage(message,"info");
	}
	 
	 <!--- show loader --->
	 loader.visible = true;
} 

<!--- just make sure we are not trying to do things on the dummy node --->
public function isValidFolder(path:String){
	return (path != "--holder--" && path != "Getting sub-directories...");
}

	
<!--- finding a specific node by a property  --->
	public function findNode(node, property, data){
   		var children = node.getChildNodes();
		var found;

		//check for this node, otherwise, go to children
		if (node.getProperty(property) == data){
			return node;
		}
		
		for (var i = 0; i < children.length; i++){
			found = findNode(children[i],property,data);
			if (found != undefined){
				//found
				return found; 
			}
		}
		return undefined;
   }
   
</cfformitem>

<!--- file upload script --->
<cfformitem type="script">	
			<cfoutput>
		var description:String = "#extensionsDescription#";
		var extension:String = "#extensions#";</cfoutput>
		var uploadSwf:Object;
		var totalSize:Number;
		var swfInitialized:Boolean = false;
		var maxSize:Number = null;
		var path:String;
		
		public function checkVersion():Void
		{
			var version = getVersion();
			var versionNumber = Number(version.substr(4,1));
			if(versionNumber < 8)
			{
				var msg = '<p>Uploading files requires Flash Player 8 <br><font color="#0000ff"><a href="http://www.macromedia.com/go/getflashplayer8">Please download it from Adobe</a></font></p>'
				var alertSettings:Object = {title:'Warning', message: msg, width:200, headerHeight:27 }
				errorpopup = mx.managers.PopUpManager.createPopUp(this, FormErrorException, true, alertSettings);
				errorpopup.centerPopUp(this);
			}
		}

		public function browse():Void
		{
			if(!swfInitialized) initSwf();
			uploadSwf.browse([{description: description, extension:extension }]);
		}
		
		public function initSwf():Void
		{
			swfInitialized = true;
			uploadSwf = swfHolder.label.upload;
			uploadSwf.addListener(this);
			
		}
		public function upload():Void
		{
			path = 'upload.cfm?path=' + directories.selectedNode.getProperty('Path') + "&" + FileExplorer.sessionVars;
			uploadSwf.upload(path);
		}
	
		public function onSelect(fileRefList:Object):Void
		{
			var list:Array = fileRefList.fileList;
			var selectedFile:Object;
			totalSize = 0;
			var tooltipText = "";
			var filesName:String = "";
			
			for(var i:Number = 0; i < list.length; i++)
			{
				selectedFile = list[i];
				totalSize += selectedFile.size;
				filesName += selectedFile.name + "; "
				tooltipText += selectedFile.name + "\n"
			}
			if( totalSize < maxSize || maxSize == null)
			{
				uploadBtn.enabled = true;
				fileToUpload.text = filesName;
			}
			fileToUpload.toolTip = tooltipText;
		}
		
		public function onProgress(fileRef, bytesLoaded, info:Object):Void
		{
			progressBar.visible = true;
			var totalWidth = progressBarBackground.width;
			var bytesTotal = totalSize;
			var kLoaded = bytesLoaded/1024;
			var kTotal = bytesTotal/1024;
			var loaded = (kLoaded < 1024) ? MathNumberParse(kLoaded) + " KB": MathNumberParse(kLoaded/1024) + " MB";
			var total = (kTotal < 1024) ? MathNumberParse(kTotal) + " KB": MathNumberParse(kTotal/1024) + " MB";
			var percentage =   Math.round(bytesLoaded * 100 / bytesTotal);
			output.text = percentage+ "% uploaded - ";
			output.text += loaded + " of " + total;
			output.text += " - " +info.index +" of "+ info.filesNum + " file(s)";
			
			progressBar.width = totalWidth / 100 * percentage;
				
		}
		
		public function MathNumberParse(n):String
		{
			return (n >> 0)+"."+ (Math.round(n*100)%100);
		}
		
		public function onFileComplete(file:Object):Void
		{
			output.text = file.name + " Loaded";
		}
		public function onComplete(file:Object):Void
		{
			output.text = "Transfer successful";
			progressBar.visible = false;
			fileUploaded();
		}
		
		public function uploadError(value):Void
		{
			output.text += value;
		}
	</cfformitem>



<cfformgroup type="horizontal" id="statusDisplay" style="marginBottom:-5; ">
	<cfformgroup type="horizontal" style="marginTop:4; marginRight:10; horizontalGap:0;">
		<cfformitem type="html"  id="statusText" style="borderStyle:none; marginTop:3;"/>
		<cfformitem type="html" width="100" height="20" id="loader" visible="false"><p><img src="loader.swf" hspace="0" vspace="0" width="100" height="14"></p></cfformitem>
	</cfformgroup>
</cfformgroup>
	
<cfformgroup type="horizontal" id="mainWin" height="{Stage.height-75}">
	<cfformgroup type="panel" label="Folders" id="foldersPanel" width="{Stage.width/2.5}">
		<cftree name="directories" onchange="onTreeChange()" height="{mainWin.height-200}">
			<cftreeitem value="/" display="#treeRootLabel#" queryasroot="No" expand="No">
			<cftreeitem value="--holder--" display="Getting sub-directories..." queryasroot="No" expand="Yes" parent="/">
		</cftree>
		<!--- delete folder button --->
		<cfformgroup type="horizontal" style="horizontalAlign:right;">
			<cfinput type="Image" name="removeFolderBtn" value="Delete Folder" onclick="submitRemoveFolder()" enabled="{(rootVerified && directories.selectedNode!=undefined && directories.selectedNode.getProperty('Path') != '')}" tooltip="{'Delet'+'e selected folder'}"  src="icons/delete.png">
		</cfformgroup>
		
		<!--- panel to create folder --->
		<cfformgroup type="panel" id="createFolderPanel" label="New Folder" width="{foldersPanel.width-20}" style="#innerPanel#"  enabled="{(rootVerified && directories.selectedNode!=undefined)}">
			<cfformitem type="text" bind="In: {directories.selectedNode.getProperty('Name')}"></cfformitem>
			<cfinput type="text" name="folderName" size="20" label="Name">
			<cfformgroup type="horizontal" label="">
				<cfinput type="button" name="createFolderBtn" value="Create Folder" onclick="submitCreateFolder()">
			</cfformgroup>
		</cfformgroup>
		
	</cfformgroup>
	
	<cfformgroup type="panel" label="Files" id="filesPanel">
		<cfformitem type="text" bind="{(directories.selectedNode!=undefined)?directories.getTreeNodeAt(0).getProperty('Name') + directories.selectedNode.getProperty('Path'):''}" style="fontWeight:bold;"></cfformitem>
		
		<cfgrid name="files" rowheaders="false" height="{mainWin.height-280}" selectmode="edit" query="files">
			<cfgridcolumn name="Type" header="" type="image" width="20" select="false">
			<cfgridcolumn name="Name">
			<cfgridcolumn name="Size" width="60" select="false" dataalign="right" type="numeric">
			<cfgridcolumn name="DateLastModified" header="Last Modified" select="false" mask="mm/dd/yy h:nn a" width="120">
			
		</cfgrid>
		
		<!--- delete & download file button --->
		<cfformgroup type="horizontal" style="horizontalAlign:right;">
			<cfinput type="Image" value="Delete File" name="removeFileBtn" enabled="{files.selectedItem!=undefined}" onclick="submitRemoveFile()" src="icons/delete.png" tooltip="{'Delet'+'e selected file'}">
			<cfformitem type="spacer" width="5"/>
			<cfinput type="Image" value="Download File" name="downloadFileBtn" enabled="{files.selectedItem!=undefined}" onclick="downloadFile()" tooltip="Download selected file" src="icons/download.png">		
		</cfformgroup>
		
		<!--- panel to upload files --->
		<cfformgroup type="panel" id="uploadFilePanel" label="Upload File" width="{filesPanel.width-20}" style="#innerPanel#"  enabled="{(rootVerified && directories.selectedNode!=undefined)}">		
			<cfformitem type="text" bind="To: {directories.selectedNode.getProperty('Name')}"></cfformitem>
				
				<!--- file upload controls --->
			<cfformgroup type="vertical" style="verticalGap:0">
					<cfformgroup type="horizontal" id="controlGroup" style="marginBottom:-5">						
						<cfinput type="text" name="fileToUpload" width="{controlGroup.width - browseBtn.width - uploadBtn.width - 40}" disabled="true">
						<cftextarea html="true" name="swfHolder" visible="false" width="0"  height="0"><p><img id="upload" hspace="0" vspace="0" src="fileUpload.swf"></p></cftextarea>
						<cfinput type="button"  name="browseBtn" onclick="browse()" value="Choose File" />
						<cfinput type="button"  name="uploadBtn" disabled="true" onclick="upload()" value="Upload File(s)" />
					</cfformgroup>
					<cfformgroup type="horizontal" style="marginBottom:-12">
						<cfinput type="button" width="0" visible="false" height="14" name="progressBar" style="#progressBarStyle#"/>
					</cfformgroup>
					<cfinput type="text" height="1" visible="false" name="progressBarBackground">
					<cfinput type="text" name="output" disabled="true" style="borderStyle:none; disabledColor:##333333;">
				</cfformgroup> 
					
		</cfformgroup>
		
	</cfformgroup>
</cfformgroup>
<!--- hidden input to store session token, only necessary due to Firefox/Safari player bug not passing correct session info in headers --->
<cfinput type="hidden" name="sessionVars" value="#session.urltoken#">
<cfformgroup type="horizontal" style="horizontalAlign:right;" height="15"><cfformitem type="html" width="150"><font size="10">Developed by <font color="##35AF20"><u><a href="http://www.blueinstant.com">Blue Instant</a></u></font></font></cfformitem></cfformgroup>
</cfform>
</body>
</html>
